renoise.tool():add_menu_entry {
  name = "Main Menu:Tools:Ledger`s Scripts:PREFERENCES:"..TOOL_NAME.." Prefs..",
  invoke = function()preferences_gui()end  
}

renoise.tool():add_keybinding {
  name = "Global:Tools:"..TOOL_NAME.." Prefs..",
  invoke = function()preferences_gui()end  
}

--global variables for gui
local my_dialog = nil 
local vb = nil

function preferences_gui()

  --toggle dialog so if its already open then close it.  The timer will catch
  --that it is closed and do the housekeeping like removing notifiers (and timer itself)
  if (my_dialog and my_dialog.visible) then 
    my_dialog:close()
    return
  end
  
  my_dialog = nil 
  vb = nil
  
  --renoise song object
  local song = renoise.song()
  
  --assign global vb as viewbuilder
  vb = renoise.ViewBuilder()
  
    --------------------------------------------------------
  --------------------------------------------------------
  --dialog content will contain all of gui; passed to renoise.app():show_custom_dialog()
  local dialog_content = vb:column{
   
    margin = 4,
    
    vb:row{
      margin = 4,
      
      vb:text{
       text = "Menus:"
      },--text
     },--row
     
     vb:column{ --one fx entry
      margin = 4,
      style = "group",
      vb:row{
       margin = 4,
      
       vb:text{
         text = "Hydra Bypass (Sampler FX Lane)"
        },--text
      },--row
     
      vb:row{
       margin = 4,
       vb:text{
        text = "Enable: ",
       },--text
      
       vb:checkbox{
        value = options.hydra_bypass_menu_show.value
       },--cbox
      
       vb:text{
        text = " Move To Sub Menu: ",
       },--text
       
       vb:checkbox{
        value = options.hydra_bypass_menu_sub.value
       },--cbox
      }--row
     }----end of one fx entry
   
    }--main col
 
  --------------
  --key Handler
  --------------
  local function my_keyhandler_func(dialog,key)
     --toggle lock focus hack, allows pattern ed to get key input
     renoise.app().window.lock_keyboard_focus = not renoise.app().window.lock_keyboard_focus
     renoise.app().window.lock_keyboard_focus = not renoise.app().window.lock_keyboard_focus
     return key
  end 
  
  ------------------------------------------------------------------------------------------
  ------------------------------------------------------------------------------------------
  --Script dialog
  my_dialog = renoise.app():show_custom_dialog(
      TOOL_NAME.." Prefs..", dialog_content,my_keyhandler_func)

  --------------------------------------------    
  --close dialog function ON NEW SONG
  --------------------------------------------
  local function closer(d)
    --close dialog if exists and is open     
    if (d ~= nil) and (d.visible == true) then
      d:close()
     -- remove_notifiers()
    end
    --reset global my_dialog2
     my_dialog = nil 
  end
  -- notifier to close dialog on load new song
  renoise.tool().app_release_document_observable:add_notifier(closer,my_dialog)
  -------------------------------------------------------------------------------

end
