TOOL_NAME = "True Track Bypass"

--Renoise Keybinds and menus
-------------------------------
renoise.tool():add_keybinding {
  name = "Global:Tools:"..TOOL_NAME,
  invoke = function()main_toggle()end  
}

renoise.tool():add_menu_entry {
  name = "Main Menu:Tools:Ledger`s Scripts:"..TOOL_NAME,
  invoke = function()main_start()end  
}

require "hydra_bypass"
require "_menu_preferences_gui"


------------------------------------------
--Set up Preferences file
------------------------------------------
--create xml
options = renoise.Document.create {
  hydra_bypass_menu_show = true,
  hydra_bypass_menu_top = true,
  hydra_bypass_menu_sub = false,
}
 --assign options-object to .preferences so renoise knows to load and update it with the tool
renoise.tool().preferences = options
------------------------------------------
------------------------------------------
--variable syntax 
--options.value_a.value


--------------------------------------------------------------------------------
--some basic colors for gui elements
--------------------------------------------------------------------------------
--e.g. For changing vb.views["sample present colour 2"].color when states change
COLOR_GREY = {0x30,0x42,0x42}
COLOR_GREY_MILD = {0x60,0x75,0x75}
COLOR_ORANGE ={0xFF,0x66,0x00}
COLOR_YELLOW = {0xE0,0xE0,0x00}
COLOR_YELLOW_MILD = {0xC0,0xC4,0x89}
COLOR_BLUE = {0x50,0x40,0xE0}  
COLOR_RED = {0xEE,0x10,0x10}
COLOR_GREEN = {0x20,0x99,0x20}
COLOR_RED_MILD = {0x90,0x10,0x10}
--COLOR_RED_MILD = {0xba,0x4a,0x5b}

--Constants holding first index of color-code: Used to identify color in vb.views table i.e.
--if vb.views["button"].color[1] == COLOR_ORANGE_FLAG then --etc
COLOR_GREY_FLAG = COLOR_GREY[1]
COLOR_GREY_MILD_FLAG = COLOR_GREY_MILD[1]
COLOR_ORANGE_FLAG = COLOR_ORANGE[1]
COLOR_YELLOW_FLAG = COLOR_YELLOW[1]
COLOR_BLUE_FLAG = COLOR_BLUE[1]  
COLOR_RED_FLAG = COLOR_RED[1]
COLOR_GREEN_FLAG = COLOR_GREEN[1]
COLOR_RED_MILD_FLAG = COLOR_RED_MILD[1]


LUA_COUNTS_FROM_1 = 1

--global variables for gui
local my_dialog = nil 
local vb = nil

local initial_button_count = 0


--toggle the tool open and closed (keyboard shortcut start-up)
-------------------------------------------------------------
function main_toggle()
----------------------
 --close dialog if it is open
  if (my_dialog and my_dialog.visible) then 
    my_dialog:close()
    --reset global my_dialog
     my_dialog = nil 
  else --run main
    main()
  end
end

--always open/ restart tool (menu entry start-up)
-------------------------------------------------
function main_start()
---------------------
  if (my_dialog and my_dialog.visible) then 
    my_dialog:close()
    --reset global my_dialog
     my_dialog = nil 
  end
  --run main
  main()
end
----------------------------------------------------------


--------------------------------------------------------------------------------
--helper function : custom status message --prefixes tool name and adds brackets 
--------------------------------------------------------------------------------
local function status(message)
  renoise.app():show_status(TOOL_NAME.." Tool: ("..message..")")
end


------------------------------------
------------------------------------
function main()
------------------------------------
------------------------------------


  --toggle dialog so if its already open then close it.  The timer will catch
  --that it is closed and do the housekeeping like removing notifiers (and timer itself)
  if (my_dialog and my_dialog.visible) then 
    my_dialog:close()
    return
  end
  
  --renoise song object
  local song = renoise.song()

  --set globals
  -------------
  --assign global vb to viewbuilder
  vb = renoise.ViewBuilder()
  
  ----------------------------------------------
  --GUI
  ----------------------------------------------     
  
  local total_trks = #song.tracks
  initial_button_count = total_trks
  --------------------------------
  --column to hold all track buttons
  local button_column = vb:column {margin = 5}
  local my_first_element = nil
  --loop to create buttons and add them to my_first_row
  for button = 1, total_trks do
    --1 button
    my_first_element = vb:row{
                         margin = 1,
                         
                         --track selection buttons
                         vb:button{
                           width = 20,
                           height = 20,
                           color = COLOR_GREY,
                           id = "trk sel btn"..button,
                           notifier = function()
                             local song = renoise.song()
                             song.selected_track_index = button
                           
                           end,
                           
                         
                         },
                         
                         --track selection buttons
                         vb:button{
                           width = 20,
                           height = 20,
                           visible = false,
                           color = COLOR_GREY,
                           text = "S",
                           id = "trk solo btn"..button,
                           notifier = function()
                             local song = renoise.song()
                             song:track(button):solo()
                             song.selected_track_index = button
                             --run timer
                             timer()
                           end,
                           
                         
                         },
                         
                         --track bypass buttons
                         vb:button { 
                           height = 20,
                           width = 80,
                           color = COLOR_GREY,
                           text = song:track(button).name,
                           id = "disable trk btn"..button,

                           notifier = function()
                              --song
                              local song = renoise.song()
                              local trk = song:track(button)
                              --select track
                            --  song.selected_track_index = button
                            
                              --SEQUENCER TRACKS
                              if trk.type == renoise.Track.TRACK_TYPE_SEQUENCER then
                                --check first col mute state
                                if trk:column_is_muted(1) == false then
                                  --mute all cols in track
                                  for i = 1,12 do
                                    trk:set_column_is_muted(i,true)
                                  end
                                  --bypass all fx
                                  for i = 2,#trk.devices do
                                    trk:device(i).is_active = false
                                  end
                                else
                                  --unmute all cols in track
                                  if trk.type == renoise.Track.TRACK_TYPE_SEQUENCER then
                                    for i = 1,12 do
                                      trk:set_column_is_muted(i,false)
                                    end
                                  end
                                  --enable all fx
                                  for i = 2,#trk.devices do
                                    trk:device(i).is_active = true
                                  end
                                end
                              else --GROUP/ SEND/ MASTER (no note cols; fx only)
                                --check there are devices on the track
                                if #trk.devices < 2 then
                                  status("No DSPs On Track To Bypass")
                                else
                                  --if are then set states
                                  if trk:device(2).is_active == true then
                                    --bypass all fx
                                    for i = 2,#trk.devices do
                                      trk:device(i).is_active = false
                                    end
                                  else
                                    --enable all fx
                                    for i = 2,#trk.devices do
                                      trk:device(i).is_active = true
                                    end
                                   end
                                 end
                             end
                            end        
                         },
                         vb:text{
                           id = "info text"..button,
                         
                         }
                         
                        }

    --add each iteration into my_first_row
    button_column:add_child(my_first_element) 
  
  end --end loop
  
  --------------------------------------------------------
  
  
  
  ----main column
  local dialog_content = vb:column{}
  --add button column
  dialog_content:add_child(button_column)


  
  --------------
  --key Handler
  --------------
  local function my_keyhandler_func(dialog,key)
     --toggle lock focus hack, allows pattern ed to get key input
     renoise.app().window.lock_keyboard_focus = not renoise.app().window.lock_keyboard_focus
     renoise.app().window.lock_keyboard_focus = not renoise.app().window.lock_keyboard_focus
    -- rprint(key)
     
     return key
     
  end 
  
 
  ------------------------------------------------------------------------------------------
  ------------------------------------------------------------------------------------------
  --Script dialog
  my_dialog = renoise.app():show_custom_dialog(
      TOOL_NAME, dialog_content,my_keyhandler_func)


  --add timer to fire once every 50ms
  if not renoise.tool():has_timer(timer) then
    renoise.tool():add_timer(timer,80)
  end

  
  --------------------------------------------    
  --close dialog function ON NEW SONG
  --------------------------------------------
  local function closer(d)
    --close dialog if exists and is open     
    if (d ~= nil) and (d.visible == true) then
      d:close()
     -- remove_notifiers()
    end
    --reset global my_dialog
     my_dialog = nil 
  end
  -- notifier to close dialog on load new song
  renoise.tool().app_release_document_observable:add_notifier(closer,my_dialog)
  -------------------------------------------------------------------------------
  
  --first run of timer
   timer()
end


----------------
--timer function
----------------
function timer()

  local song = renoise.song()

  if initial_button_count ~= #song.tracks then 
  
    --restart tool function
    -----------------------------
    local function restart_tool() 
    -----------------------------
      --remove_notifiers()
       -- toggle dialog off then on
      if (my_dialog and my_dialog.visible) then 
        my_dialog:close()
        --restart
        main_start()
      end
    end
    --has user changed track count in renoise by adding/ removing tracks?
    --if so then restart/rebuild the tool (easy way to update gui though resets to centre position and causes `flash`)
    restart_tool()
    return
 
  end
 
  
  local selected_track_idx = song.selected_track_index
  
  --update track names on buttons
  -------------------------------
  for track = 1,#song.tracks do
    vb.views["disable trk btn"..track].text = song:track(track).name
  end
  
  local brk_loop = false
  
  --update track selection buttons colors
  ---------------------------------------
  --default all to grey
  for track = 1,#song.tracks do
    local trk = song:track(track)
    if trk.type == renoise.Track.TRACK_TYPE_SEQUENCER then
      vb.views["trk sel btn"..track].color = COLOR_GREY
    else
      vb.views["trk sel btn"..track].color = COLOR_GREY_MILD
    end
    --update text [X] to show if current pattern is bypassed
    if song.sequencer:track_sequence_slot_is_muted(track, song.selected_sequence_index) == true then
      vb.views["trk sel btn"..track].text = "X"
    else
      vb.views["trk sel btn"..track].text = ""
    end 
  end
  
  for track = 1,#song.tracks do
    if track == selected_track_idx then
      vb.views["trk sel btn"..track].color = COLOR_GREEN
    end
  end
  
  
  --solo buttons
  -------------
  --default all to grey
  for track = 1,#song.tracks do
    local trk = song:track(track)
    if trk.type == renoise.Track.TRACK_TYPE_SEQUENCER then
      vb.views["trk solo btn"..track].color = COLOR_GREY
    else
      vb.views["trk solo btn"..track].color = COLOR_GREY
    end
  end 
  --default all to grey
  for track = 1,#song.tracks do
    local trk = song:track(track)
    if song:track(track).solo_state == true then
      if trk.type == renoise.Track.TRACK_TYPE_SEQUENCER then
        vb.views["trk solo btn"..track].color = COLOR_YELLOW
      else
        vb.views["trk solo btn"..track].color = COLOR_YELLOW_MILD
      end
    end
  end 
  
  
  --update DISABLE TRACK buttons
  ------------------------------
  --check track status
  for track = 1,#song.tracks do
    local trk = song:track(track)
    --default all buttons to grey
    if trk.type == renoise.Track.TRACK_TYPE_SEQUENCER then
      vb.views["disable trk btn"..track].color = COLOR_GREY
    else
      vb.views["disable trk btn"..track].color = COLOR_GREY
    end
    --sequencer tracks go red when disabled
    if trk.type == renoise.Track.TRACK_TYPE_SEQUENCER then
      if (trk:column_is_muted(1) == true) then
       vb.views["disable trk btn"..track].color = COLOR_RED_MILD
      end
    else --groups sends and master go orange when disabled
      local all_bypassed = true
      --loop track devices
      for dev = 2, #trk.devices do
        if trk:device(dev).is_active == true then
          all_bypassed = false
        end
      end
       --when no DSP on non-seq tracks, reset flag
      if #trk.devices == 1 then
        all_bypassed = false
      end
      --set orange when bypassed fx populate the track
      if all_bypassed == true then
        vb.views["disable trk btn"..track].color = COLOR_ORANGE
      end
    end
  end
 
  --set track button widths so long track names wont over-run
  for track = 1,#song.tracks do
    vb.views["disable trk btn"..track].width = 100
  end
  --update info text
  for track = 1,#song.tracks do 
    local trk = song:track(track)
    --for unumted tracks
    local bypassed_devs = false
    if vb.views["disable trk btn"..track].color[1] == COLOR_GREY_FLAG then
      for i = 2,#trk.devices do
        if trk:device(i).is_active == false then
          bypassed_devs = true
          break
        end
      end
    end

    if bypassed_devs == false then
      vb.views["info text"..track].text = ""
    else
      vb.views["info text"..track].text = "*"
    end

  end 
  
  --remove timer when GUI is closed
  if(my_dialog == nil) or (my_dialog.visible == false) then
    if renoise.tool():has_timer(timer) then
      renoise.tool():remove_timer(timer)
    end
  end
end




